<%@ page contentType="text/html"%>
<%@ page pageEncoding="UTF-8"%>
<%@ page session="true" %>
<%@ page errorPage="ErrorPage.jsp" %>
<%@ page import="model.*" %>
<%@ page import="java.util.*" %>
<%@ page import="java.io.*" %>

<jsp:useBean id="model" class="model.Model" scope="session"/>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/2002/REC-xhtml1-20020801/DTD/xhtml1-transitional.dtd">

<% if (model.getUsername().equals("")) throw new ServletException("No such a username is found in calling adminCurrentRuns.jsp "); %>    
    
<%
    String navBar = "<a href='./logout'>Home (Logout)</a>&nbsp;>&nbsp;<a href='servlet/controller/Link?page=login.jsp'>Login</a>&nbsp;>&nbsp;<a href='servlet/controller/Link?page=runnableProgramsList.jsp'>Programs</a>&nbsp;>&nbsp;Current Runs";
%>

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="EN" lang="EN">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
        <title>CCP4 online</title>
        <jsp:include page="initialisation.jsp" flush="false"/>
    </head>
    
    <body>

        <div id="container">
        
        <%@ include file="./header.jsp"%>
        
        <div id="header">
            <div id="breadcrumb">
                <ul>
                    <div id='leftNav'><%=navBar%></div>
                    <div id='rightNav'>Username: <strong><%=model.getUsername()%></strong></div>
                </ul>
                <div class="clear">&nbsp;</div>
            </div>
        </div>
        
        <div id="content-container">
        
        <div id="container2">
        
        <h2>Current Runs</h2>
        
        <br />
        
        <%
        model.setRunnableProgramsOutputBaseDir(application.getInitParameter("runnableProgramsOutputBaseDir"));
        
        if (model.validAdminUser() == false) {
            out.println("<h2>YOU DO NOT HAVE PERMISSION TO VIEW THIS PAGE</h2>");
        } else { %>
        
        <div id="currentRunsTable">
        <table>
        
        <% model.setAdminSort("date"); %>
            
        <tr>
        <th>&nbsp;Program Type&nbsp;</th>
        <th>&nbsp;User&nbsp;</th>
        <th>&nbsp;id&nbsp;</th>
        <th>&nbsp;Date&nbsp;<a href='adminCurrentRuns.jsp'>REFRESH</a>&nbsp;</th>
        <th>&nbsp;Time (Test)&nbsp;</th> 
        <th>&nbsp;Status&nbsp;</th>
        </tr>
        
        <%
        List list = model.getAdminList();
        for (Iterator it = list.iterator(); it.hasNext();) {
            request.setAttribute("adminTable", it.next());
        %>
            <jsp:useBean id="adminTable" scope="request" type="model.Admin"/>
        
            <tr>
                <td><jsp:getProperty name="adminTable" property="programType"/></td>
                <td><jsp:getProperty name="adminTable" property="user"/></td>
                <td><jsp:getProperty name="adminTable" property="id"/></td>
                <td><jsp:getProperty name="adminTable" property="date"/></td>
                <td><jsp:getProperty name="adminTable" property="startingProcessTime"/><jsp:getProperty name="adminTable" property="processRunningTime"/></td>
                <td><jsp:getProperty name="adminTable" property="status"/></td>
            </tr>
        <%  } %>
        
        </table>
                
        </div>
        
        <% } %>
        
        <br /><br />
        
        </div>
        
        <div class="clear">&nbsp;</div>
        
        </div>
        
        </div>

        <jsp:include page="WEB-INF/jspf/footer.jspf"/>
    
    </body>

</html>
