<%@ page contentType="text/html"%>
<%@ page pageEncoding="UTF-8"%>
<%@ page session="true"%>
<%@ page errorPage="ErrorPage.jsp"%>
<%@ page import="model.*"%>

<jsp:useBean id="model" scope="session" class="model.Model" />

<!-- comment -->
<!DOCTYPE html>

<%
	String navBar = "<a href='./index.jsp'>Home</a>";
	String passstr = application.getInitParameter("runnableProgramsPasswdFile");
%>

<%
	if (model.getRunnableProgramsPasswdFile() == null || model.getRunnableProgramsPasswdFile().equals("")) {
		String str = application.getInitParameter("runnableProgramsPasswdFile");
		model.setRunnableProgramsPasswdFile(str);
	}
%>

<html lang="EN">
<head>
<meta charset="UTF-8" />
<meta http-equiv="X-UA-Compatible" content="IE=9;chrome=1" />
<title>CCP4 online</title>
<%@include file="initialisation.jsp"%>
</head>

<body>
	<div class="container">

		<%@ include file="./header.jsp"%>

		<div id="header">
			<div id="breadcrumb">
			<!--
				<ul>
					<div id='leftNav'><%=navBar%></div>
				</ul>
				<div class="clear">&nbsp;</div>
				-->
			</div>
		</div>

		<!--
		<div id="content-container">
		-->
		<div class="pure-g" id="content-container">

			<div class="pure-u-1-24">
			</div>

			<!--
			<div id="middleColumn">
			-->
			<div class="pure-u-17-24">
				<h1>Welcome to CCP4 online</h1>
				
				<!--
				<p>
				<span class='error'><strong>*** The cluster is currently under maintenance. No new jobs will be submitted
					at the moment. The service will be up again in the next days. ***</strong></span><br/> 
				</p>
				-->
				<!--
				<p>
				<span class='error'><strong>*** The output for some of the services (CRANK2, SHELX, MoRDa, AMPLE) is currently
				disabled. They will be up again in the next days. The other services (Balbes, MrBUMP, Zanuda, jsPISA) work normally.
				***</strong></span><br/> 
				</p>
				-->

				<p>
				<a href="./login.jsp?process=false">Login</a> <br /> <br /> Other
				Options - <a href="./register.jsp?process=false">Register</a>, <a
					href='./forgottenPassword.jsp?process=false'>Forgotten Password</a>,
				<a href="./changePassword.jsp?process=false">Change Password</a>
				</p>

				<h2>Runnable programs</h2>

				<p>The following programs and pipelines are available:</p>

				<dl>
					<dt>Balbes</dt>
					<dd>An automated Molecular Replacement (MR) pipeline - Balbes
						integrates into one system all the components necessary for
						solving a crystal structure by Molecular Replacement</dd>
					<dt>MrBUMP</dt>
					<dd>An automated Molecular Replacement (MR) pipeline - Given a
						target sequence and experimental structure factors, it will search
						for homologous structures, create a set of suitable search models
						from the template structures, do molecular replacement, and test
						the solutions with some rounds of restrained refinement.</dd>
					<dt>Zanuda</dt>
					<dd>Space group and crystallographic origin validation</dd>
					<dt>
						<a href="http://www.ccp4.ac.uk/pisa">jsPISA</a>
					</dt>
					<dd>Calculation and analysis of macromolecular surfaces and
						interfaces</dd>
					<dt>AMPLE</dt>
					<dd>Automated ab initio search model generation for molecular
						replacement.</dd>
					<dt>SHELX</dt>
					<dd>Automated SHELXC/D/E structure solution pipeline for fast 
					routine experimental phasing. Accepts data in XDS, Scalepack, SHELX hkl or 
					mtz formats and outputs phases and a poly-Ala trace. If a protein sequence 
					is provided, BUCCANEER and REFMAC complete the structure. <font color="red">BETA</font></dd>
					<dt>CRANK2</dt>
					<dd>Automated structure solution pipeline for experimental phasing 
					using maximum likelihood methods. 
					<font color="red">BETA</font></dd>
					<dt>MoRDa</dt>
					<dd>MoRDa is a pipeline for molecular replacement protein structure solution based on its
					own domain database. Models relevant to the target sequence are further adjusted before
					molecular replacement search.</dd>
				</dl>

				<p>
				NB. CCP4 online does not seem to work on Internet Explorer at
				the moment. Please use some other browser for the time being. Sorry for the
				inconvenience.
				</p>
			</div>

			<!--
			<div id="rightColumn">
			-->
			<div class="pure-u-1-4">
				<div id="noBorder">
					<table style="margin-top: 0px; text-align: center" class="center">
						<tr>
							<td><img src="./images/rightSpacer.gif" border="0"
								alt="spacer" /></td>
						</tr>
						<tr>
							<td><a href="http://www.mrc.ac.uk/" target="blank"
								class="noHover"><img src="./images/mrc_logo.gif" border="0"
									alt="welcome trust logo" /></a></td>
						</tr>
						<tr>
							<td><img src="./images/rightSpacer.gif" border="0"
								alt="spacer" /></td>
						</tr>
						<tr>
							<td><img src="./images/rightSpacer.gif" border="0"
								alt="spacer" /></td>
						</tr>
						<tr>
							<td><a href="http://www.bbsrc.ac.uk/" target="blank"
								class="noHover"><img src="./images/new_bbsrc_colour4.jpg"
									border="0" alt="bbsrc logo" /></a></td>
						</tr>
						<tr>
							<td><img src="./images/rightSpacer.gif" border="0"
								alt="spacer" /></td>
						</tr>
						<tr>
							<td><img src="./images/rightSpacer.gif" border="0"
								alt="spacer" /></td>
						</tr>
						<tr>
							<td><a href="http://www.rc-harwell.ac.uk/" target="blank"
								class="noHover"><img src="./images/rcah_logo.gif" border="0"
									alt="rcah logo" height=50 /></a></td>
						</tr>
						<tr>
							<td><img src="./images/rightSpacer.gif" border="0"
								alt="spacer" /></td>
						</tr>
						<tr>
							<td><img src="./images/rightSpacer.gif" border="0"
								alt="spacer" /></td>
						</tr>
						<tr>
							<td><a href="http://www.liverpool.ac.uk/" target="blank"
								class="noHover"><img src="./images/University-of-Liverpool-logo.gif" border="0"
									alt="Univ of Liverpool logo" height=40 /></a></td>
						</tr>
						<tr>
							<td><img src="./images/rightSpacer.gif" border="0"
								alt="spacer" /></td>
						</tr>
						<tr>
							<td><img src="./images/rightSpacer.gif" border="0"
								alt="spacer" /></td>
						</tr>
						<tr>
							<td><a href="http://www.universiteitleiden.nl/" target="blank"
								class="noHover"><img src="./images/zegel.png" border="0"
									alt="Leiden University logo" height=40 /></a></td>
						</tr>
						<tr>
							<td><img src="./images/rightSpacer.gif" border="0"
								alt="spacer" /></td>
						</tr>
						<tr>
							<td><img src="./images/rightSpacer.gif" border="0"
								alt="spacer" /></td>
						</tr>
						<tr>
							<td><a href="http://uni-goettingen.de/" target="blank"
								class="noHover"><img src="./images/goettingen.jpg" border="0"
									alt="University of Goettingen logo" height=40 /></a></td>
						</tr>
					</table>
				</div>
			</div>

		</div>
	</div>

	<jsp:include page="WEB-INF/jspf/footer.jspf" />
</body>

</html>
